# mypy-boto3-s3control

[![PyPI - mypy-boto3-s3control](https://img.shields.io/pypi/v/mypy-boto3-s3control.svg?color=blue)](https://pypi.org/project/mypy-boto3-s3control)
[![PyPI - Python Version](https://img.shields.io/pypi/pyversions/mypy-boto3-s3control.svg?color=blue)](https://pypi.org/project/mypy-boto3-s3control)
[![Docs](https://img.shields.io/readthedocs/mypy-boto3-builder.svg?color=blue)](https://mypy-boto3-builder.readthedocs.io/)

![boto3.typed](https://github.com/vemel/mypy_boto3_builder/raw/master/logo.png)

Type annotations for
[boto3.S3Control 1.17.42](https://boto3.amazonaws.com/v1/documentation/api/1.17.42/reference/services/s3control.html#S3Control) service
compatible with
[VSCode](https://code.visualstudio.com/),
[PyCharm](https://www.jetbrains.com/pycharm/),
[Emacs](https://www.gnu.org/software/emacs/),
[Sublime Text](https://www.sublimetext.com/),
[mypy](https://github.com/python/mypy),
[pyright](https://github.com/microsoft/pyright)
and other tools.

Generated by [mypy-boto3-buider 4.4.0](https://github.com/vemel/mypy_boto3_builder).

More information can be found on [boto3-stubs](https://pypi.org/project/boto3-stubs/) page.

See how it helps to find and fix potential bugs:

![boto3-stubs demo](https://github.com/vemel/mypy_boto3_builder/raw/master/demo.gif)

- [mypy-boto3-s3control](#mypy-boto3-s3control)
  - [How to install](#how-to-install)
  - [Usage](#usage)
    - [VSCode](#vscode)
    - [PyCharm](#pycharm)
    - [Other IDEs](#other-ides)
    - [mypy](#mypy)
    - [pyright](#pyright)
  - [Explicit type annotations](#explicit-type-annotations)
    - [Client annotations](#client-annotations)
    - [Paginators annotations](#paginators-annotations)
    - [Waiters annotations](#waiters-annotations)
    - [Service Resource annotations](#service-resource-annotations)
    - [Other resources annotations](#other-resources-annotations)
    - [Collections annotations](#collections-annotations)
    - [Typed dictionations](#typed-dictionations)

## How to install

Install `boto3-stubs` for `S3Control` service.

```bash
python -m pip install boto3-stubs[s3control]
```

## Usage

### VSCode

- Install [Python extension](https://marketplace.visualstudio.com/items?itemName=ms-python.python)
- Install [Pylance extension](https://marketplace.visualstudio.com/items?itemName=ms-python.vscode-pylance)
- Set `Pylance` as your Python Language Server
- Install `boto-stubs[s3control]` in your environment: `python -m pip install 'boto3-stubs[s3control]'`

Both type checking and auto-complete should work for `S3Control` service.
No explicit type annotations required, write your `boto3` code as usual.

### PyCharm

- Install `boto-stubs[s3control]` in your environment: `python -m pip install 'boto3-stubs[s3control]'`

Both type checking and auto-complete should work for `S3Control` service.
No explicit type annotations required, write your `boto3` code as usual.
Auto-complete can be slow on big projects or if you have a lot of installed `boto3-stubs` submodules.

### Other IDEs

Not tested, but as long as your IDE support `mypy` or `pyright`, everything should work.

### mypy

- Install `mypy`: `python -m pip install mypy`
- Install `boto-stubs[s3control]` in your environment: `python -m pip install 'boto3-stubs[s3control]'`
- Run `mypy` as usual

Type checking should work for `S3Control` service.
No explicit type annotations required, write your `boto3` code as usual.

### pyright

- Install `pyright`: `yarn global add pyright`
- Install `boto-stubs[s3control]` in your environment: `python -m pip install 'boto3-stubs[s3control]'`
- Optionally, you can install `boto3-stubs` to `typings` folder.

Type checking should work for `S3Control` service.
No explicit type annotations required, write your `boto3` code as usual.

## Explicit type annotations

### Client annotations

`S3ControlClient` provides annotations for `boto3.client("s3control")`.

```python
import boto3

from mypy_boto3_s3control import S3ControlClient

client: S3ControlClient = boto3.client("s3control")

# now client usage is checked by mypy and IDE should provide code auto-complete

# works for session as well
session = boto3.session.Session(region="us-west-1")
session_client: S3ControlClient = session.client("s3control")
```

### Paginators annotations

`mypy_boto3_s3control.paginator` module contains type annotations for all paginators.

```python
from mypy_boto3_s3control import S3ControlClient
from mypy_boto3_s3control.paginator import (
    ListAccessPointsForObjectLambdaPaginator,
)

client: S3ControlClient = boto3.client("s3control")

# Explicit type annotations are optional here
# Type should be correctly discovered by mypy and IDEs
# VSCode requires explicit type annotations
list_access_points_for_object_lambda_paginator: ListAccessPointsForObjectLambdaPaginator = client.get_paginator("list_access_points_for_object_lambda")
```







### Typed dictionations

`mypy_boto3_s3control.type_defs` module contains structures and shapes assembled
to typed dictionaries for additional type checking.

```python
from mypy_boto3_s3control.type_defs import (
    AbortIncompleteMultipartUploadTypeDef,
    AccessPointTypeDef,
    AccountLevelTypeDef,
    ActivityMetricsTypeDef,
    AwsLambdaTransformationTypeDef,
    BucketLevelTypeDef,
    ExcludeTypeDef,
    IncludeTypeDef,
    JobDescriptorTypeDef,
    JobFailureTypeDef,
    JobListDescriptorTypeDef,
    JobManifestLocationTypeDef,
    JobManifestSpecTypeDef,
    JobManifestTypeDef,
    JobOperationTypeDef,
    JobProgressSummaryTypeDef,
    JobReportTypeDef,
    LambdaInvokeOperationTypeDef,
    LifecycleExpirationTypeDef,
    LifecycleRuleAndOperatorTypeDef,
    LifecycleRuleFilterTypeDef,
    LifecycleRuleTypeDef,
    ListStorageLensConfigurationEntryTypeDef,
    NoncurrentVersionExpirationTypeDef,
    NoncurrentVersionTransitionTypeDef,
    ObjectLambdaAccessPointTypeDef,
    ObjectLambdaConfigurationTypeDef,
    ObjectLambdaContentTransformationTypeDef,
    ObjectLambdaTransformationConfigurationTypeDef,
    PolicyStatusTypeDef,
    PrefixLevelStorageMetricsTypeDef,
    PrefixLevelTypeDef,
    PublicAccessBlockConfigurationTypeDef,
    RegionalBucketTypeDef,
    ResponseMetadata,
    S3AccessControlListTypeDef,
    S3AccessControlPolicyTypeDef,
    S3BucketDestinationTypeDef,
    S3CopyObjectOperationTypeDef,
    S3GrantTypeDef,
    S3GranteeTypeDef,
    S3InitiateRestoreObjectOperationTypeDef,
    S3ObjectLockLegalHoldTypeDef,
    S3ObjectMetadataTypeDef,
    S3ObjectOwnerTypeDef,
    S3RetentionTypeDef,
    S3SetObjectAclOperationTypeDef,
    S3SetObjectLegalHoldOperationTypeDef,
    S3SetObjectRetentionOperationTypeDef,
    S3SetObjectTaggingOperationTypeDef,
    S3TagTypeDef,
    SSEKMSTypeDef,
    SelectionCriteriaTypeDef,
    StorageLensAwsOrgTypeDef,
    StorageLensConfigurationTypeDef,
    StorageLensDataExportEncryptionTypeDef,
    StorageLensDataExportTypeDef,
    StorageLensTagTypeDef,
    TransitionTypeDef,
    VpcConfigurationTypeDef,
    CreateAccessPointForObjectLambdaResultTypeDef,
    CreateAccessPointResultTypeDef,
    CreateBucketConfigurationTypeDef,
    CreateBucketResultTypeDef,
    CreateJobResultTypeDef,
    DescribeJobResultTypeDef,
    GetAccessPointConfigurationForObjectLambdaResultTypeDef,
    GetAccessPointForObjectLambdaResultTypeDef,
    GetAccessPointPolicyForObjectLambdaResultTypeDef,
    GetAccessPointPolicyResultTypeDef,
    GetAccessPointPolicyStatusForObjectLambdaResultTypeDef,
    GetAccessPointPolicyStatusResultTypeDef,
    GetAccessPointResultTypeDef,
    GetBucketLifecycleConfigurationResultTypeDef,
    GetBucketPolicyResultTypeDef,
    GetBucketResultTypeDef,
    GetBucketTaggingResultTypeDef,
    GetJobTaggingResultTypeDef,
    GetPublicAccessBlockOutputTypeDef,
    GetStorageLensConfigurationResultTypeDef,
    GetStorageLensConfigurationTaggingResultTypeDef,
    LifecycleConfigurationTypeDef,
    ListAccessPointsForObjectLambdaResultTypeDef,
    ListAccessPointsResultTypeDef,
    ListJobsResultTypeDef,
    ListRegionalBucketsResultTypeDef,
    ListStorageLensConfigurationsResultTypeDef,
    PaginatorConfigTypeDef,
    TaggingTypeDef,
    UpdateJobPriorityResultTypeDef,
    UpdateJobStatusResultTypeDef,
)

def get_structure() -> AbortIncompleteMultipartUploadTypeDef:
    return {
      ...
    }
```
